;ladowarka MCH V1
;program obslugi matrycy LCD DOGS104B
;przerwanie od TMR0
;zegarek
;definiowanie staych
line1_lcd EQU 080H
line2_lcd equ 094H		
line3_lcd EQU 0C0H
line4_lcd EQU 0D4H
line1_big EQU 01FH			;pierwszy wiersz LCD duy i dwa male
line2_big EQU 017H			;2 wiersz LCD duy i 1 i 3 wiersz maly
line3_big EQU 013H			;3 wiersz LCD duy i 1 i 2 wiersz maly
line_big EQU 01BH			;2 wiersze (1 i 2) LCD due
clr_lcd equ 01h
shift_cursorr equ 014h
shift_cursorl EQU 010H
cursor_off equ 0CH
cursor_on equ 0DH
;definiowanie zmiennych
#define key1 PORTB, 6		;klawisz nr 1
#define key2 PORTB, 7		;klawisz nr 2
#define key3 PORTB, 5		;klawisz nr 3
#define key4 PORTB, 4		;klawisz nr 4
;
#define dph 20h				;starszy bajt pomocniczy
#define dpl 21h				;mlodszy bajt pomocniczy
#define licznik 22h				;mlodszy bajt pomocniczy
#define stos 23h				;mlodszy bajt pomocniczy
#define hx10 24h				;dziesiatki godzin
#define hx1 25h				;dziesiatki jednoci = 1000x mAh
#define mx10 26h				;dziesiatki minut = 100x mAh
#define mx1 27h				;jednostki minut  = 10x mAh
#define sx10 28h				;dziesiatki sekund = 1x mAh
#define sx1 29h				;jednostki sekund
#define pom 2ah				;rejestr pomocniczy
#define i2cdata 2bh		;dane wysylane przez 
#define licznik1 2ch				;mlodszy bajt pomocniczy
#define c_bat4 2dh
#define c_bat3 2eh
#define c_bat2 2fh
#define c_bat1 30h
#define stos1 31h
#define bit_reg 32h			;rejestr w ktorym korzysta sie z bitow
							;bit_reg.0 ustawiony w chwili inkrementacji czasu
#define stos3 33h
#define tab_reg 34h			;rejestr zawierajacy inf. ktora tabele wyswietla fun. monitor
							;01h - TAB_MENU1 02h - TAB_MENU2 .....	
;
#define acu1_stat 35h		;01h - ladowanie AA
#define acu2_stat 36h		;02h - ladowanie AAA
#define acu3_stat 37h		;04h - pom. C AA
#define acu4_stat 38h		;08h - pom. C AAA	
							;10h - ready
							;20h - w trakcie ladowania, byl juz rozladowany
							;80h - NC - brak baterii
;
#define mAhx1 039h			; dla aku AAA
#define mAhx10 03Ah			; dla aku AAA
#define mAhx100 03Bh		; dla aku AAA
#define mAhx1000 03Ch		; dla aku AAA
;
#define acu_test_reg 03Dh	;01h - Uacu<1,05V
							;02h - Uacu>1,43V
;
#define AAA1 PORTC, 2		;AKU1, 0 - rozladowanie aku AAA, 1- rozladowanie aku AA
#define AAA2 PORTD, 0		;AKU2 ,0 - rozladowanie aku AAA, 1- rozladowanie aku AA
#define AAA3 PORTC, 0		;AKU3 ,0 - rozladowanie aku AAA, 1- rozladowanie aku AA
#define AAA4 PORTC, 1		;AKU3 ,0 - rozladowanie aku AAA, 1- rozladowanie aku AA
;
#define ID1_ON PORTB, 0		;AKU1, 0 - rozladowanie aku ON
#define ID2_ON PORTB, 1		;AKU2, 0 - rozladowanie aku ON
#define ID3_ON PORTB, 2		;AKU3, 0 - rozladowanie aku ON
#define ID4_ON PORTB, 3		;AKU2, 0 - rozladowanie aku ON
;
#define I1_ON_A PORTD, 1		;AKU1, 0 - ladowanie AKU1 - 1/2 pradu
#define I1_ON_B PORTD, 2		;AKU1, 0 - ladowanie AKU1 - 2/2 pradu
#define I2_ON_A PORTC, 5		;AKU2, 0 - ladowanie AKU2 - 1/2 pradu
#define I2_ON_B PORTC, 6		;AKU2, 0 - ladowanie AKU2 - 2/2 pradu
#define I3_ON_A PORTD, 6		;AKU3, 0 - ladowanie AKU3 - 1/2 pradu
#define I3_ON_B PORTD, 7		;AKU3, 0 - ladowanie AKU3 - 2/2 pradu
#define I4_ON_A PORTC, 7		;AKU4, 0 - ladowanie AKU4 - 1/2 pradu
#define I4_ON_B PORTD, 4		;AKU4, 0 - ladowanie AKU4 - 2/2 pradu
;deklaracj typu procesora i formatu liczb
	list p=16F877A			;okreslenie typu procesora
	#include p16f877A.inc	;dolaczenie pliku z nazwami

;konfiguracja procesora
	__config _XT_OSC &_WDT_OFF &_PWRTE_ON &_BODEN_OFF &_DEBUG_OFF &_CP_OFF &_CPD_OFF &_LVP_OFF;
;OSC:
;	LP - low power - zewnetrzny kwarc zegarkowy 32kHz
;	XT - kwarc 455kHz - 4MHz
;	HS - kwarc 8-16MHz
;	RS - zewnetrzny RC
;
;WDT - WATCHDOG
;PWRTE - ON - po wlazeniu zasilania 72ms zwloki (reset) do ustabilizowania napicia
;BODEN - reset przy obnizebiu Udd - wylacz dla 3,3V
;CP - ochrona pamici programu przed odczytem
;CPD - ochrona pameci eeprom przed odczytem
;LVP - off programowanie z ISP - RB3 I/O
;
org 0
	goto start
org h'04'
;f=Fosc/8/prscaler/tmr0
	movlw h'08' 				;wpisanie do PC adresu powyzej 2kB
	movwf pclath
	call timer0_int
	retfie
;tablica wlasnych znakow LCD
TAB_BAT0 
	ADDWF PCL, 1
	RETLW b'00001110'	;bat 0/5C
	RETLW b'00011111'
	RETLW b'00010001'
	RETLW b'00010001'
	RETLW b'00010001'
	RETLW b'00010001'
	RETLW b'00011111'
	RETLW b'00000000'
;
	RETLW b'00001110'	;bat 1/5C
	RETLW b'00011111'
	RETLW b'00010001'
	RETLW b'00010001'
	RETLW b'00010001'
	RETLW b'00010001'
	RETLW b'00011111'
	RETLW b'00000000'
;
	RETLW b'00001110'	;bat 2/5C
	RETLW b'00011111'
	RETLW b'00010001'
	RETLW b'00010001'
	RETLW b'00010001'
	RETLW b'00011111'
	RETLW b'00011111'
	RETLW b'00000000'
;
	RETLW b'00001110'	;bat 3/5C
	RETLW b'00011111'
	RETLW b'00010001'
	RETLW b'00010001'
	RETLW b'00011111'
	RETLW b'00011111'
	RETLW b'00011111'
	RETLW b'00000000'
;
	RETLW b'00001110'	;bat 4/5C
	RETLW b'00011111'
	RETLW b'00010001'
	RETLW b'00011111'
	RETLW b'00011111'
	RETLW b'00011111'
	RETLW b'00011111'
	RETLW b'00000000'
;
	RETLW b'00001110'	;bat 5/5C
	RETLW b'00011111'
	RETLW b'00011111'
	RETLW b'00011111'
	RETLW b'00011111'
	RETLW b'00011111'
	RETLW b'00011111'
	RETLW b'00000000'
;
TAB_MENU1 		;napis od tyu
	ADDWF PCL, 1
	RETLW #'?'; '1 AA/AAA ?'
	RETLW #' ' 
	RETLW #'A'
	RETLW #'A'
	RETLW #'A'
	RETLW #'/'
	RETLW #'A'
	RETLW #'A'
	RETLW #' '
	RETLW #'1'
TAB_MENU2 		;napis od tyu
	ADDWF PCL, 1
	RETLW #'T'; '0123456789'
	RETLW #'S'; '1 CHG/C_M?' 
	RETLW #'E'
	RETLW #'T'
	RETLW #'/'
	RETLW #'G'
	RETLW #'H'
	RETLW #'C'
	RETLW #' '
	RETLW #'1'
start
	bcf status, rp0		;bank 0
	clrf portb			;wyzerowanie portu zatrzaskowego portu B
	clrf portd			;wyzerowanie portu zatrzaskowego portu D
	bcf intcon, gie		;wylaczenie przerwan
	bcf intcon, tmr0ie			;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	bsf status, rp0		;bank1
	movlw b'11110000'			
	movwf trisb			;b7-b4 wejscia klawisze
	movlw h'00'			; 
	movwf trisd			;wyjscia
	movlw b'00101111'			; 
	movwf trisa			;wyjscia; AN0 - wejscie ADC
	movlw h'00'			; 
	movwf trisc			;wyjscia
	movlw h'00'			; 
	movwf trise			;wyjscia
	bcf option_reg, 7	;wlaczenie rezystorow podciagajacych
	bsf pcon, 0			;BOR OFF
	bcf status, rp0		;bank0
	movlw h'00'			; 
	movwf sspcon 		;wyjscia
	movlw h'00'			; 
	movwf ccp2con 		;PWM2 i Comparator2 off
;
	movlw h'00'			; 
	movwf ccp1con 		;PWM1 i Comparator1 off
;
	bsf status, rp0		;bank 1
	movlw b'00000000'			; 
	movwf sspstat 		;I2C 
	movlw b'0000000'			; 
	movwf sspcon2 		;I2C off - udostepnienie linii SDA i CLK
	bcf status, rp0		;bank 0
	movlw b'00001000'			; 
	movwf sspcon 		;I2C off - udostepnienie linii SDA i CLK
;
	movlw h'00'			; 
	movwf rcsta 		;serial port off
	movlw h'00'			; 
	movwf t1con 		;timer 1 off
	movlw h'00'			; 
	movwf t2con 		;timer 2 off
	movlw h'00'			; 
	movwf t2con 		;timer 2 off
	bsf status, rp0		;bank1
	movlw b'00000111'	; rezystory wlaczone; timer fosc/4/256 
	movwf option_reg 		
	bcf status, rp0		;bank0
;
	movlw h'A1'			; 
	movwf adcon0 		;ADC on AN4 (RA5)
	bsf status, rp0		;bank1
	movlw b'00000001'			; shift - L; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	movwf adcon1 		;wszystkie AN sa liniami analogowymi iAN3 = +ref
	bcf status, rp0		;bank0
;
	movlw h'010' 
	movwf c_bat4 		;symbol baterii 25%
	movlw h'02' 
	movwf c_bat3		;symbol baterii 50%
	movlw h'04' 
	movwf c_bat2		;symbol baterii 75%
	movlw h'08' 
	movwf c_bat1		;symbol baterii 100%
;	movwf acu1_stat
	clrf acu1_stat		
	movlw h'80'			; brak aku
	movwf acu2_stat
	movwf acu3_stat
	movwf acu4_stat
	movlw h'01' 
	movwf tab_reg	
	goto menu0 			;skok do glownej pentli wykonywania programu
;****************************************************************************************************************
new_ch
	banksel trisc	
	movlw b'00011000'			; 
	movwf trisc			;wyjscia
	banksel sspcon
	movlw b'00101000'			; 
	movwf sspcon			;
	banksel sspstat
	movlw b'10000000'			; 
	movwf sspstat
	banksel sspadd			;
	movlw h'7C'			; 
	movwf sspadd
	banksel sspcon2
	bsf sspcon2, sen	;start
	call i2c_wait
	movlw h'78'			
	movwf sspbuf		;adres dogs104b 078h (zapis)
	call i2c_wait
	movlw h'80'			
	movwf sspbuf		;control byte - RAM
	call i2c_wait
	movlw h'40'			
	movwf sspbuf		;zapisz A
	call i2c_wait
;
	movlw h'40'			
	movwf sspbuf		;zapisz A
	call i2c_wait
;	
	movlw h'00'
	movwf licznik
new_ch1
	call TAB_BAT0
	movwf sspbuf		;zapisz A
	call i2c_wait
	incf licznik, 0
	movwf licznik
	btfss licznik, 5
	goto new_ch1
	btfss licznik, 4
	goto new_ch1
	call i2c_wait
;
	banksel sspcon2
	bsf sspcon2, pen	;bit stop
	bcf status, rp0		;bank 0
	call i2c_wait
	return
;*******************************************************
;funkcja inicjalizacji matrycy LCD
init_lcd
	bcf status, rp0		;bank0
	bcf intcon, gie		;wylaczenie przerwan
	call delay10
	call delay10
	call delay10
	call delay10
	call delay10
	banksel trisc	
	movlw b'00011000'			; 
	movwf trisc			;wyjscia
	banksel sspcon
	movlw b'00101000'			; 
	movwf sspcon			;
	banksel sspstat
	movlw b'10000000'			; 
	movwf sspstat
	banksel sspadd			;
	movlw h'7C'			; 
	movwf sspadd
	banksel sspcon2
	bsf sspcon2, sen	;start
	call i2c_wait
	movlw h'78'			
	movwf sspbuf		;adres dogs104b 078h (zapis)
	call i2c_wait
;dogs104
;******************************************************************
	movlw h'80'			
	movwf sspbuf		;adres dogs104b 078h (zapis)
	call i2c_wait
	movlw h'3A'			
	movwf sspbuf
	call i2c_wait
;
	movlw h'09'			
	movwf sspbuf
	call i2c_wait
;
	movlw h'06'			
	movwf sspbuf
	call i2c_wait
;
	movlw h'1E'			
	movwf sspbuf
	call i2c_wait
;
	movlw h'39'			
	movwf sspbuf
	call i2c_wait
;
	movlw h'1B'			
	movwf sspbuf
	call i2c_wait
;
	movlw h'6E'			
	movwf sspbuf
	call i2c_wait
;
	movlw h'56'			
	movwf sspbuf
	call i2c_wait
;
	movlw h'7A'			
	movwf sspbuf
	call i2c_wait
;
	movlw h'38'			
	movwf sspbuf
	call i2c_wait
;
	movlw h'0C'			
	movwf sspbuf		;
	call i2c_wait
;
	banksel sspcon2
	bsf sspcon2, pen	;bit stop
	bcf status, rp0		;bank 0
	call i2c_wait
	return
;****************************************************
;glowna petla programu
menu0
; 		
	call init_lcd		;inicjalizacja matrycy LCD
	call new_ch			;tworzenie wlasnych zankow 
;
;
	movlw h'08' 			;wpisanie do PC adresu powyzej 2kB
	movwf pclath
;
	call reset_port		;poczatkowe ustawienia portow
	movlw #clr_lcd
	movwf i2cdata
	call lcd
;
;
	movlw h'08' 			;wpisanie do PC adresu powyzej 2kB
	movwf pclath
;
	call time_reset			;zerowanie wskazan zegara
;
	movlw h'08' 			;wpisanie do PC adresu powyzej 2kB
	movwf pclath
	call BIG				;pierwszy wiersz duzy
;
	call acu1_set			;ustawienie akcji dla aku1
	movlw h'01' 
	movwf tab_reg	
	call acu2_set			;ustawienie akcji dla aku2
	btfsc acu2_stat, 7		; czu obecny acu2
	goto menu1
	movlw h'01' 
	movwf tab_reg	
	call acu3_set			;ustawienie akcji dla aku3
	btfsc acu3_stat, 7		; czu obecny acu2
	goto menu1
	movlw h'01' 
	movwf tab_reg	
	call acu4_set			;ustawienie akcji dla aku4
menu1
	movlw #cursor_off
	movwf i2cdata
	call lcd
	btfsc acu4_stat, 7
	goto menu1a
	movlw h'38'
	movwf i2cdata			;mala czcionka
	call lcd
menu1a
	movlw #clr_lcd
	movwf i2cdata
	call lcd
	movlw #'1'
	movwf i2cdata
	call write_lcd
	movlw h'FC'
	movwf licznik
	btfsc acu1_stat, 0
	goto menu1b			;ladowanie
	btfss acu1_stat, 1
	goto menu1c			;rozladowanie
menu1b				;ladowanie
	movlw #shift_cursorr
	movwf i2cdata
	call lcd
	incf licznik, 1
	btfsc licznik, 7
	goto menu1b
	movlw #'0'
	movwf i2cdata
	call write_lcd
	movlw #'%'
	movwf i2cdata
	call write_lcd
	goto menu1d			;drugie ogniwo
menu1c					;test
	movlw #shift_cursorr
	movwf i2cdata
	call lcd
	incf licznik, 1
	btfsc licznik, 7
	goto menu1c
	movlw #'0'
	movwf i2cdata
	call write_lcd
	movlw #'m'
	movwf i2cdata
	call write_lcd
	movlw #'A'
	movwf i2cdata
	call write_lcd
	movlw #'h'
	movwf i2cdata
	call write_lcd
menu1d
	btfsc acu2_stat, 7
	goto menu2
	movlw #line2_lcd
	movwf i2cdata
	call lcd
	movlw #'2'
	movwf i2cdata
	call write_lcd
	movlw h'FC'
	movwf licznik
	btfsc acu2_stat, 0
	goto menu1e			;ladowanie
	btfss acu2_stat, 1
	goto menu1f			;rozladowanie
menu1e				;ladowanie
	movlw #shift_cursorr
	movwf i2cdata
	call lcd
	incf licznik, 1
	btfsc licznik, 7
	goto menu1e
	movlw #'0'
	movwf i2cdata
	call write_lcd
	movlw #'%'
	movwf i2cdata
	call write_lcd
	goto menu1g			;drugie ogniwo
menu1f					;test
	movlw #shift_cursorr
	movwf i2cdata
	call lcd
	incf licznik, 1
	btfsc licznik, 7
	goto menu1f
	movlw #'0'
	movwf i2cdata
	call write_lcd
	movlw #'m'
	movwf i2cdata
	call write_lcd
	movlw #'A'
	movwf i2cdata
	call write_lcd
	movlw #'h'
	movwf i2cdata
	call write_lcd
menu1g
	btfsc acu3_stat, 7
	goto menu2
	movlw #line3_lcd
	movwf i2cdata
	call lcd
	movlw #'3'
	movwf i2cdata
	call write_lcd
	movlw h'FC'
	movwf licznik
	btfsc acu3_stat, 0
	goto menu1h			;ladowanie
	btfss acu3_stat, 1
	goto menu1i			;rozladowanie
menu1h				;ladowanie
	movlw #shift_cursorr
	movwf i2cdata
	call lcd
	incf licznik, 1
	btfsc licznik, 7
	goto menu1h
	movlw #'0'
	movwf i2cdata
	call write_lcd
	movlw #'%'
	movwf i2cdata
	call write_lcd
	goto menu1j			;drugie ogniwo
menu1i					;test
	movlw #shift_cursorr
	movwf i2cdata
	call lcd
	incf licznik, 1
	btfsc licznik, 7
	goto menu1i
	movlw #'0'
	movwf i2cdata
	call write_lcd
	movlw #'m'
	movwf i2cdata
	call write_lcd
	movlw #'A'
	movwf i2cdata
	call write_lcd
	movlw #'h'
	movwf i2cdata
	call write_lcd
menu1j
	btfsc acu4_stat, 7
	goto menu2
	movlw #line4_lcd
	movwf i2cdata
	call lcd
	movlw #'4'
	movwf i2cdata
	call write_lcd
	movlw h'FC'
	movwf licznik
	btfsc acu4_stat, 0
	goto menu1k			;ladowanie
	btfss acu4_stat, 1
	goto menu1l			;rozladowanie
menu1k				;ladowanie
	movlw #shift_cursorr
	movwf i2cdata
	call lcd
	incf licznik, 1
	btfsc licznik, 7
	goto menu1k
	movlw #'0'
	movwf i2cdata
	call write_lcd
	movlw #'%'
	movwf i2cdata
	call write_lcd
	goto menu2			;drugie ogniwo
menu1l					;test
	movlw #shift_cursorr
	movwf i2cdata
	call lcd
	incf licznik, 1
	btfsc licznik, 7
	goto menu1l
	movlw #'0'
	movwf i2cdata
	call write_lcd
	movlw #'m'
	movwf i2cdata
	call write_lcd
	movlw #'A'
	movwf i2cdata
	call write_lcd
	movlw #'h'
	movwf i2cdata
	call write_lcd
;
menu2
	movlw b'10100000'	;  
	movwf intcon	;przerwanie od timera - inne zablokowane 		
menu2a
	btfss bit_reg, 0		;znacznik uplywy czasu
	goto $-1				;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;menu2a
	call acu1			;absulga acu1
	bcf status, rp0		;bank0
	bcf status, rp1		;bank0
	call delay100ms
	call acu2			;absulga acu2
	bcf status, rp0		;bank0
	bcf status, rp1		;bank0
	call delay100ms
	call acu3			;absulga acu3
	bcf status, rp0		;bank0
	bcf status, rp1		;bank0
	call delay100ms
	call acu4			;			;absulga acu4
	bcf status, rp0		;bank0
	bcf status, rp1		;bank0
	call delay100ms
	bcf bit_reg, 0		;!!!!!!!!!!!!!!!!
	goto menu2a
;****************************************************************
;FUNKCJE POMOCNICZE CD.
;*****************************************************************
;zapis na matryce LCD
WRITE_LCD
	banksel trisc	
	movlw b'00011000'			; 
	movwf trisc			;wyjscia
	banksel sspcon
	movlw b'00101000'			; 
	movwf sspcon			;
	banksel sspstat
	movlw b'10000000'			; 
	movwf sspstat
	banksel sspadd			;
	movlw h'7C'			; 
	movwf sspadd
	bcf intcon, gie
	banksel sspcon2
	bsf sspcon2, sen	;start
	call i2c_wait
	movlw h'78'			
	movwf sspbuf		;adres dogs104b 078h (zapis)
	call i2c_wait
	movlw h'40'			
	movwf sspbuf		;control byte - RAM
	call i2c_wait
	movf i2cdata, 0		;przeslij i2cdata do W
	movwf sspbuf		;zapisz A
	call i2c_wait
	banksel sspcon2
	bsf sspcon2, pen	;bit stop
	bcf status, rp0		;bank 0
	call i2c_wait
	bsf intcon, gie
	return
; procedura obslugi matrycy Lcd 
LCD
	banksel trisc	
	movlw b'00011000'			; 
	movwf trisc			;wyjscia
	banksel sspcon
	movlw b'00101000'			; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	movwf sspcon			;
	banksel sspstat
	movlw b'10000000'			; 
	movwf sspstat
	banksel sspadd			;
	movlw h'7C'			; 
	movwf sspadd
	bcf intcon, gie
	banksel sspcon2
	bsf sspcon2, sen	;start
	call i2c_wait
	movlw h'78'			
	movwf sspbuf		;adres dogs104b 078h (zapis)
	call i2c_wait
	movlw h'80'			
	movwf sspbuf		;control byte - RAM
	call i2c_wait
;	call delay0255		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	movf i2cdata, 0		;przeslij i2cdata do W
	movwf sspbuf		;zapisz A
	call i2c_wait
;	call delay0255		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	banksel sspcon2
	bsf sspcon2, pen	;bit stop
	bcf status, rp0		;bank 0
	call i2c_wait
	bsf intcon, gie
	call delay0255		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	call delay0255		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	return
;funkcja sprawdzania zajetosci i2c
i2c_wait
;	movlw h'80'			
;	movwf c_bat4		
;i2c_wait0
	banksel sspstat
	btfsc sspstat, R_W
	goto $-2
;	goto i2c_wait2
;	bcf status, rp0		;bank 0
;	incf c_bat4, 1
;	btfsc c_bat4, 7
;	goto i2c_wait0
;	bcf I4_ON_A 	;AKU4 ladowanie AKU4 - 1/2 pradu OFF
;	bcf I4_ON_B 	;AKU4 ladowanie AKU4 - 2/2 pradu OFF	
;	goto $
;i2c_wait2
	banksel sspcon2
	movf sspcon2, w
	andlw h'1f'
	btfss status, z
	goto $-4
;	goto i2c_wait_end
;	incf c_bat4, 1
;	btfsc c_bat4, 7
;	goto i2c_wait2
;	bcf I4_ON_A 	;AKU4 ladowanie AKU4 - 1/2 pradu OFF
;	bcf I4_ON_B 	;AKU4 ladowanie AKU4 - 2/2 pradu OFF	
;	goto $
;i2c_wait_end
	bcf status, rp0		;bank 0
	bcf status, rp1		;bank 0
	return
;opoznienie o 255us
delay0255
	movlw h'46'	; 
	movwf dpl
delay0255_0				; funkcja opoxnienia 0 255us
	decfsz dpl, 0		;
	goto delay0255_1
	goto delay0255_end
delay0255_1
	movwf dpl
	goto delay0255_0
delay0255_end
	return
;opoznienie o 10 ms
delay10
	movlw h'0b'		;1 bylo 0bh
delay10a
	movwf dph		;1
	movlw h'f2'		;1
delay10b
	movwf dpl	;przepisuja W do dpl
	decfsz dpl,0		;1 dekrement, wynik do W, jesli 0 pomin next instr.
	goto delay10b	;1
	movlw dph	;	wpisz do W dph
	decfsz dph,0	;1 zmniejsz dph, wynik do W, jesli 0 pomin next instr.
	goto delay10a	;1
	return	
;opoznienie o 100ms
delay100ms
	movwf stos3 	;zapamietuje W na stosie
	movlw .10
	movwf licznik
	call delay10
	decfsz licznik, 1
	goto $-2
	movf stos3, 0	;oddaje wartosc W
	return
;ustawienie parametrow acu1
acu1_set
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	call monitor
acu1_set0a
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	movlw h'FD'
	movwf licznik
acu1_set0
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	incf licznik, 1
	btfsc licznik, 7
	goto acu1_set0
	movlw h'0D'			;wlacz kursor AA
	movwf i2cdata		
	call LCD
	movlw h'05'			
	movwf acu1_stat
acu1_set1
	btfss key1
	goto acu1_set1c
	btfsc key3
	goto acu1_set1
	movlw h'FC'
	movwf licznik
acu1_set1a
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	incf licznik, 1
	btfsc licznik, 7
	goto acu1_set1a
	movlw h'0A'			
	movwf acu1_stat
acu1_set1b
	btfss key1
	goto acu1_set1c ;AAA
	btfsc key2
	goto acu1_set1b
	goto acu1_set0a
acu1_set1c
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	movlw h'02'
	movwf tab_reg	;tbele TAB_MENU2
	call monitor	;wpisanie tablicy do 1 wiersza LCD
acu1_set1c1
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	movlw h'FC'
	movwf licznik
acu1_set1d
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	incf licznik, 1
	btfsc licznik, 7
	goto acu1_set1d
	call delay100ms
acu1_set1e
	btfss key1
	goto acu1_set1f ;ladowanie
	btfsc key3
	goto acu1_set1e
	movlw h'FB'
	movwf licznik
acu1_set1g
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	incf licznik, 1
	btfsc licznik, 7
	goto acu1_set1g
acu1_set1h
	btfss key1
	goto acu1_set1i ;pomiar C
	btfsc key2
	goto acu1_set1h
	goto acu1_set1c1
acu1_set1i			;pomiar C
	bcf acu1_stat, 0	;wyl. ladowanie AA
	bcf acu1_stat, 1	;wyl. ladowanie	AAA
	bcf acu1_set, 7		;aku obecny
	goto acu1_set_end
acu1_set1f			; ladowanie
	bcf acu1_stat, 3	;wyl. pom. C
	bcf acu1_stat, 2	;wyl. pom C
	bcf acu1_set, 7		;aku obecny
acu1_set_end
	btfss key1
	goto acu1_set_end
	btfss key2
	goto acu1_set_end
	btfss key3
	goto acu1_set_end
	btfss key4
	goto acu1_set_end
	call delay100ms
	return
;ustawienie parametrow acu2
acu2_set
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	call monitor
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	movlw '2'
	movwf i2cdata
	call write_lcd
acu2_set0a
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	movlw h'FD'
	movwf licznik
acu2_set0
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	incf licznik, 1
	btfsc licznik, 7
	goto acu2_set0
	movlw h'0D'			;wlacz kursor AA
	movwf i2cdata		
	call LCD
	movlw h'05'			
	movwf acu2_stat
acu2_set1
	btfsc key4			;esc - brak baterii
	goto acu2_set1a1
	movlw h'80'			
	movwf acu2_stat
	goto acu2_set_end
acu2_set1a1
	btfss key1
	goto acu2_set1c
	btfsc key3
	goto acu2_set1
	movlw h'FC'
	movwf licznik
acu2_set1a
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	incf licznik, 1
	btfsc licznik, 7
	goto acu2_set1a
	movlw h'0A'			
	movwf acu2_stat
acu2_set1b
	btfss key1
	goto acu2_set1c ;AAA
	btfsc key2
	goto acu2_set1b
	goto acu2_set0a
acu2_set1c
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	movlw h'02'
	movwf tab_reg	;tbele TAB_MENU2
	call monitor	;wpisanie tablicy do 1 wiersza LCD
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	movlw '2'
	movwf i2cdata
	call write_lcd
acu2_set1c1
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	movlw h'FC'
	movwf licznik
acu2_set1d
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	incf licznik, 1
	btfsc licznik, 7
	goto acu2_set1d
	call delay100ms
acu2_set1e
	btfss key1
	goto acu2_set1f ;ladowanie
	btfsc key3
	goto acu2_set1e
	movlw h'FB'
	movwf licznik
acu2_set1g
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	incf licznik, 1
	btfsc licznik, 7
	goto acu2_set1g
acu2_set1h
	btfss key1
	goto acu2_set1i ;pomiar C
	btfsc key2
	goto acu2_set1h
	goto acu2_set1c1
acu2_set1i			;pomiar C
	bcf acu2_stat, 0	;wyl. ladowanie AA
	bcf acu2_stat, 1	;wyl. ladowanie	AAA
	bcf acu2_set, 7		;aku obecny
	goto acu2_set_end
acu2_set1f			; ladowanie
	bcf acu2_stat, 3	;wyl. pom. C
	bcf acu2_stat, 2	;wyl. pom C
	bcf acu2_set, 7		;aku obecny
acu2_set_end
	btfss key1
	goto acu2_set_end
	btfss key2
	goto acu2_set_end
	btfss key3
	goto acu2_set_end
	btfss key4
	goto acu2_set_end
	call delay100ms
	return
;ustawienie parametrow acu3
acu3_set
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	call monitor
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	movlw '3'
	movwf i2cdata
	call write_lcd
acu3_set0a
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	movlw h'FD'
	movwf licznik
acu3_set0
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	incf licznik, 1
	btfsc licznik, 7
	goto acu3_set0
	movlw h'0D'			;wlacz kursor AA
	movwf i2cdata		
	call LCD
	movlw h'05'			
	movwf acu3_stat
acu3_set1
	btfsc key4			;esc - brak baterii
	goto acu3_set1a1
	movlw h'80'			
	movwf acu3_stat
	goto acu3_set_end
acu3_set1a1
	btfss key1
	goto acu3_set1c
	btfsc key3
	goto acu3_set1
	movlw h'FC'
	movwf licznik
acu3_set1a
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	incf licznik, 1
	btfsc licznik, 7
	goto acu3_set1a
	movlw h'0A'			
	movwf acu3_stat
	call delay100ms
acu3_set1b
	btfss key1
	goto acu3_set1c ;AAA
	btfsc key2
	goto acu3_set1b
	goto acu3_set0a
acu3_set1c
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	movlw h'02'
	movwf tab_reg	;tbele TAB_MENU2
	call monitor	;wpisanie tablicy do 1 wiersza LCD
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	movlw '3'
	movwf i2cdata
	call write_lcd
acu3_set1c1
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	movlw h'FC'
	movwf licznik
acu3_set1d
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	incf licznik, 1
	btfsc licznik, 7
	goto acu3_set1d
	call delay100ms
acu3_set1e
	btfss key1
	goto acu3_set1f ;ladowanie
	btfsc key3
	goto acu3_set1e
	movlw h'FB'
	movwf licznik
acu3_set1g
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	incf licznik, 1
	btfsc licznik, 7
	goto acu3_set1g
acu3_set1h
	btfss key1
	goto acu3_set1i ;pomiar C
	btfsc key2
	goto acu3_set1h
	goto acu3_set1c1
acu3_set1i			;pomiar C
	bcf acu3_stat, 0	;wyl. ladowanie AA
	bcf acu3_stat, 1	;wyl. ladowanie	AAA
	bcf acu3_set, 7		;aku obecny
	goto acu3_set_end
acu3_set1f			; ladowanie
	bcf acu3_stat, 3	;wyl. pom. C
	bcf acu3_stat, 2	;wyl. pom C
	bcf acu3_set, 7		;aku obecny
acu3_set_end
	btfss key1
	goto acu3_set_end
	btfss key2
	goto acu3_set_end
	btfss key3
	goto acu3_set_end
	btfss key4
	goto acu3_set_end
	call delay100ms
	return
;ustawienie parametrow acu4
acu4_set
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	call monitor
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	movlw '4'
	movwf i2cdata
	call write_lcd
acu4_set0a
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	movlw h'FD'
	movwf licznik
acu4_set0
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	incf licznik, 1
	btfsc licznik, 7
	goto acu4_set0
	movlw #cursor_on			;wlacz kursor AA
	movwf i2cdata		
	call LCD
	movlw h'05'			
	movwf acu4_stat
acu4_set1
	btfsc key4			;esc - brak baterii
	goto acu4_set1a1
	movlw h'80'			
	movwf acu4_stat
	goto acu4_set_end
acu4_set1a1
	btfss key1
	goto acu4_set1c
	btfsc key3
	goto acu4_set1
	movlw h'FC'
	movwf licznik
acu4_set1a
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	incf licznik, 1
	btfsc licznik, 7
	goto acu4_set1a
	movlw h'0A'			
	movwf acu4_stat
acu4_set1b
	btfss key1
	goto acu4_set1c ;AAA
	btfsc key2
	goto acu4_set1b
	goto acu4_set0a
acu4_set1c
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	movlw h'02'
	movwf tab_reg	;tbele TAB_MENU2
	call monitor	;wpisanie tablicy do 1 wiersza LCD
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	movlw '4'
	movwf i2cdata
	call write_lcd
acu4_set1c1
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	movlw h'FC'
	movwf licznik
acu4_set1d
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	incf licznik, 1
	btfsc licznik, 7
	goto acu4_set1d
	call delay100ms
acu4_set1e
	btfss key1
	goto acu4_set1f ;ladowanie
	btfsc key3
	goto acu4_set1e
	movlw h'FB'
	movwf licznik
acu4_set1g
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	incf licznik, 1
	btfsc licznik, 7
	goto acu4_set1g
acu4_set1h
	btfss key1
	goto acu4_set1i ;pomiar C
	btfsc key2
	goto acu4_set1h
	goto acu4_set1c1
acu4_set1i			;pomiar C
	bcf acu4_stat, 0	;wyl. ladowanie AA
	bcf acu4_stat, 1	;wyl. ladowanie	AAA
	bcf acu4_set, 7		;aku obecny
	goto acu4_set_end
acu4_set1f			; ladowanie
	bcf acu4_stat, 3	;wyl. pom. C
	bcf acu4_stat, 2	;wyl. pom C
	bcf acu4_set, 7		;aku obecny
acu4_set_end
	btfss key1
	goto acu4_set_end
	btfss key2
	goto acu4_set_end
	btfss key3
	goto acu4_set_end
	btfss key4
	goto acu4_set_end
	call delay100ms
	return
;funkcja wpisywania 1 wiersza txt z tabeli na LCD
monitor
	movlw h'00' 			;wpisanie do PC adresu powyzej 2kB
	movwf pclath
;
	movlw h'F6'
	movwf licznik
	movlw h'09'
monitor2
	btfsc tab_reg, 0
	goto monitor2a
	btfsc tab_reg, 1
	goto monitor2b
monitor2a
	call TAB_MENU1
	goto monitor3
monitor2b
	call TAB_MENU2
	goto monitor3
monitor3
	movwf i2cdata
	call write_lcd
	movf licznik, 0
	sublw h'FE'
	incf licznik, 1
	btfsc licznik, 7
	goto monitor2
	return
;*****************************************************
;obsluga acu1
acu1
	btfsc acu1_stat, 4		;
	goto acu1_end
	btfsc acu1_stat, 2
	goto acu1a				;pom C AA
	btfss acu1_stat, 3
	goto acu1b
	bsf AAA1 		;AKU1, rozladowanie aku AAA
	bcf ID1_ON 		;AKU1 rozladowanie aku1 ON
	movlw #line1_lcd
	movwf i2cdata
	call lcd	
	call display_caaa	;wyswietlenie pojemnoci AAA
	call disp_bat1_dch
	goto acu1c
acu1a
	bcf AAA1 		;AKU1, rozladowanie aku AA
	bcf ID1_ON 		;AKU1 rozladowanie aku1 ON
	movlw #line1_lcd
	movwf i2cdata
	call lcd	
	call display_caa	;wyswietlenie pojemnoci AA
	call disp_bat1_dch
acu1c
	call acu1_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 0	
	goto acu1d				;Uacu>1,05V
	call delay10
	call acu1_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 0	
	goto acu1d				;Uacu>1,05V
	call delay10
	call acu1_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfsc acu_test_reg, 0	
	goto acu1e				;rozladowany
acu1d				;Uacu>1,05V
	call disp_bat1_dch
	goto acu1_end
acu1e
;acu1 rozladowany	
	bcf AAA1 		;AKU1, rozladowanie aku AAA
	bsf ID1_ON 		;AKU1 rozladowanie aku1 OFF
	movlw h'10'
	movwf c_bat1			;Uacu>1,05V
	call disp_bat1_dch
	bsf acu1_stat, 4		;ukonczono proces pomiaru
	goto acu1_end
;**************************************************
acu1b					;ladowanie
	btfsc acu1_stat, 5	;czy byl rozladowany
	goto acu1b1
	bcf AAA1 		;AKU1, rozladowanie aku AA
	bcf ID1_ON 		;AKU1 rozladowanie aku1 ON
	call disp_bat1_dch
	call delay10
	btfss key1				;pominiecie funkcji rozladowania  !!!!!!!!!!!!!!!!!!!!!!!!!
	goto acu1b2				;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	call acu1_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 0	
	goto acu1_end			;nie jest rozladowany
	call delay10
	call acu1_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 0	
	goto acu1_end			;nie jest rozladowany
	call delay10
	call acu1_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 0	
	goto acu1_end			;nie jest rozladowany
acu1b2
	bsf ID1_ON 		;AKU1 rozladowanie aku1 OFF
	bcf I1_ON_A		;LADOWANIE 125mA
	btfsc acu1_stat, 0	; czy AA
	bcf I1_ON_B		;LADOWANIE 250mA
	bsf acu1_stat, 5	;zapis ze byk rozladowany
acu1b1				
	call disp_bat1_ch
	call acu1_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 1	
	goto acu1_end
	call delay100ms
	call acu1_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 1	
	goto acu1_end
	call delay100ms
	call acu1_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 1	
	goto acu1_end
	bsf I1_ON_A		;LADOWANIE 125mA OFF
	bsf I1_ON_B		;LADOWANIE 250mA OFF
	movlw h'40'
	movwf c_bat1			
	call disp_bat1_ch
	bsf acu1_stat, 4		;ukonczono proces adowania
	movlw #line1_lcd
	movwf i2cdata
	call lcd	
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	movlw #'1'
	movwf i2cdata
	call write_lcd
	movlw #'0'
	movwf i2cdata
	call write_lcd	
	movlw #'0'
	movwf i2cdata
	call write_lcd
	goto acu1_end			;funkcja ladowania
acu1_end
	return
;*****************************************************
;obsluga acu2
acu2
	btfsc acu2_stat, 7		;
	goto acu2_end
	btfsc acu2_stat, 4		;
	goto acu2_end
	btfsc acu2_stat, 2
	goto acu2a				;pom C AA
	btfss acu2_stat, 3
	goto acu2b
	bsf AAA2 		;AKU2, rozladowanie aku AAA
	bcf ID2_ON 		;AKU2 rozladowanie aku2 ON
	movlw #line2_lcd
	movwf i2cdata
	call lcd	
	call display_caaa	;wyswietlenie pojemnoci AAA
	call disp_bat2_dch
	goto acu2c
acu2a
	bcf AAA2 		;AKU2, rozladowanie aku AA
	bcf ID2_ON 		;AKU2 rozladowanie aku2 ON
	movlw #line2_lcd
	movwf i2cdata
	call lcd	
	call display_caa	;wyswietlenie pojemnoci AA
	call disp_bat2_dch
acu2c
	call acu2_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 0	
	goto acu2d				;Uacu>1,05V
	call delay10
	call acu2_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 0	
	goto acu2d				;Uacu>1,05V
	call delay10
	call acu2_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfsc acu_test_reg, 0	
	goto acu2e				;rozladowany
acu2d				;Uacu>1,05V
	call disp_bat2_dch
	goto acu2_end
acu2e
;acu2 rozladowany	
	bcf AAA2 		;AKU2, rozladowanie aku AAA
	bsf ID2_ON 		;AKU2 rozladowanie aku2 OFF
	movlw h'10'
	movwf c_bat2			;Uacu>1,05V
	call disp_bat2_dch
	bsf acu2_stat, 4		;ukonczono proces pomiaru
	goto acu2_end
;**************************************************
acu2b
	btfsc acu2_stat, 5	;czy byl rozladowany
	goto acu2b1
	bcf AAA2 		;AKU2, rozladowanie aku AA
	bcf ID2_ON 		;AKU2 rozladowanie aku2 ON
	call disp_bat2_dch
	call delay10
	btfss key2				;pominiecie funkcji rozladowania  !!!!!!!!!!!!!!!!!!!!!!!!!
	goto acu2b2				;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	call acu2_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 0	
	goto acu2_end			;nie jest rozladowany
	call delay10
	call acu2_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 0	
	goto acu2_end			;nie jest rozladowany
	call delay10
	call acu2_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 0	
	goto acu2_end			;nie jest rozladowany
acu2b2
	bsf ID2_ON 		;AKU2 rozladowanie aku2 OFF
	bcf I2_ON_A		;LADOWANIE 125mA
	btfsc acu2_stat, 0	; czy AA
	bcf I2_ON_B		;LADOWANIE 250mA
	bsf acu2_stat, 5	;zapis ze byk rozladowany
acu2b1				
	call disp_bat2_ch
	call acu2_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 1	
	goto acu2_end
	call delay100ms
	call acu2_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 1	
	goto acu2_end
	call delay100ms
	call acu2_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 1	
	goto acu2_end
	bsf I2_ON_A		;LADOWANIE 125mA OFF
	bsf I2_ON_B		;LADOWANIE 250mA OFF
	movlw h'40'
	movwf c_bat2			
	call disp_bat2_ch
	bsf acu2_stat, 4		;ukonczono proces adowania
	movlw #line2_lcd
	movwf i2cdata
	call lcd	
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	movlw #'1'
	movwf i2cdata
	call write_lcd
	movlw #'0'
	movwf i2cdata
	call write_lcd	
	movlw #'0'
	movwf i2cdata
	call write_lcd
	goto acu2_end			;funkcja ladowania
acu2_end
	return
;*****************************************************
;obsluga acu3
acu3
	btfsc acu3_stat, 7		;
	goto acu3_end
	btfsc acu3_stat, 4		;
	goto acu3_end
	btfsc acu3_stat, 2
	goto acu3a				;pom C AA
	btfss acu3_stat, 3
	goto acu3b
	bsf AAA3 		;AKU3, rozladowanie aku AAA
	bcf ID3_ON 		;AKU3 rozladowanie aku3 ON
	movlw #line3_lcd
	movwf i2cdata
	call lcd	
	call display_caaa	;wyswietlenie pojemnoci AAA
	call disp_bat3_dch
	goto acu3c
acu3a
	bcf AAA3 		;AKU3, rozladowanie aku AA
	bcf ID3_ON 		;AKU3 rozladowanie aku3 ON
	movlw #line3_lcd
	movwf i2cdata
	call lcd	
	call display_caa	;wyswietlenie pojemnoci AA
	call disp_bat3_dch
acu3c
	call acu3_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 0	
	goto acu3d				;Uacu>1,05V
	call delay10
	call acu3_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 0	
	goto acu3d				;Uacu>1,05V
	call delay10
	call acu3_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfsc acu_test_reg, 0	
	goto acu3e				;rozladowany
acu3d				;Uacu>1,05V
	call disp_bat3_dch
	goto acu3_end
acu3e
;acu3 rozladowany	
	bcf AAA3 		;AKU3, rozladowanie aku AAA
	bsf ID3_ON 		;AKU3 rozladowanie aku3 OFF
	movlw h'10'
	movwf c_bat3			;Uacu>1,05V
	call disp_bat3_dch
	bsf acu3_stat, 4		;ukonczono proces pomiaru
	goto acu3_end
;**************************************************
acu3b
	btfsc acu3_stat, 5	;czy byl rozladowany
	goto acu3b1
	bcf AAA3 		;AKU3, rozladowanie aku AA
	bcf ID3_ON 		;AKU3 rozladowanie aku3 ON
	call disp_bat3_dch
	call delay10
	btfss key3				;pominiecie funkcji rozladowania  !!!!!!!!!!!!!!!!!!!!!!!!!
	goto acu3b2				;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	call acu3_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 0	
	goto acu3_end			;nie jest rozladowany
	call delay10
	call acu3_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 0	
	goto acu3_end			;nie jest rozladowany
	call delay10
	call acu3_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 0	
	goto acu3_end			;nie jest rozladowany
acu3b2
	bsf ID3_ON 		;AKU3 rozladowanie aku3 OFF
	bcf I3_ON_A		;LADOWANIE 125mA
	btfsc acu3_stat, 0	; czy AA
	bcf I3_ON_B		;LADOWANIE 250mA
	bsf acu3_stat, 5	;zapis ze byk rozladowany
acu3b1				
	call disp_bat3_ch
	call acu3_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 1	
	goto acu3_end
	call delay100ms
	call acu3_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 1	
	goto acu3_end
	call delay100ms
	call acu3_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 1	
	goto acu3_end
	bsf I3_ON_A		;LADOWANIE 125mA OFF
	bsf I3_ON_B		;LADOWANIE 250mA OFF
	movlw h'40'
	movwf c_bat3			
	call disp_bat3_ch
	bsf acu3_stat, 4		;ukonczono proces adowania
	movlw #line3_lcd
	movwf i2cdata
	call lcd	
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	movlw #'1'
	movwf i2cdata
	call write_lcd
	movlw #'0'
	movwf i2cdata
	call write_lcd	
	movlw #'0'
	movwf i2cdata
	call write_lcd
	goto acu3_end			;funkcja ladowania
acu3_end
	return
;*****************************************************
;obsluga acu4
acu4
	btfsc acu4_stat, 4		;
	goto acu4_end
	btfsc acu4_stat, 2
	goto acu4a				;pom C AA
	btfss acu4_stat, 3
	goto acu4b
	bsf AAA4 		;AKU3, rozladowanie aku AAA
	bcf ID4_ON 		;AKU3 rozladowanie aku3 ON
	movlw #line4_lcd
	movwf i2cdata
	call lcd	
	call display_caaa	;wyswietlenie pojemnoci AAA
	call disp_bat4_dch
	goto acu4c
acu4a
	bcf AAA4 		;AKU3, rozladowanie aku AA
	bcf ID4_ON 		;AKU3 rozladowanie aku3 ON
	movlw #line4_lcd
	movwf i2cdata
	call lcd	
	call display_caa	;wyswietlenie pojemnoci AA
	call disp_bat4_dch
acu4c
	call acu4_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 0	
	goto acu4d				;Uacu>1,05V
	call delay10
	call acu4_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 0	
	goto acu4d				;Uacu>1,05V
	call delay10
	call acu4_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfsc acu_test_reg, 0	
	goto acu4e				;rozladowany
acu4d				;Uacu>1,05V
	call disp_bat4_dch
	goto acu4_end
acu4e
;acu4 rozladowany	
	bcf AAA4 		;AKU3, rozladowanie aku AAA
	bsf ID4_ON 		;AKU3 rozladowanie aku3 OFF
	movlw h'10'
	movwf c_bat4			;Uacu>1,05V
	call disp_bat4_dch
	bsf acu4_stat, 4		;ukonczono proces pomiaru
	goto acu4_end
;**************************************************
acu4b
	btfsc acu4_stat, 5	;czy byl rozladowany
	goto acu4b1
	bcf AAA4 		;AKU3, rozladowanie aku AA
	bcf ID4_ON 		;AKU3 rozladowanie aku3 ON
	call disp_bat4_dch
	call delay10
	btfss key4				;pominiecie funkcji rozladowania  !!!!!!!!!!!!!!!!!!!!!!!!!
	goto acu4b2				;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	call acu4_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 0	
	goto acu4_end			;nie jest rozladowany
	call delay10
	call acu4_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 0	
	goto acu4_end			;nie jest rozladowany
	call delay10
	call acu4_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 0	
	goto acu4_end			;nie jest rozladowany
acu4b2
	bsf ID4_ON 		;AKU3 rozladowanie aku3 OFF
	bcf I4_ON_A		;LADOWANIE 125mA
	btfsc acu4_stat, 0	; czy AA
	bcf I4_ON_B		;LADOWANIE 250mA
	bsf acu4_stat, 5	;zapis ze byk rozladowany
acu4b1				
	call disp_bat4_ch
	call acu4_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 1	
	goto acu4_end
	call delay100ms
	call acu4_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 1	
	goto acu4_end
	call delay100ms
	call acu4_pom
	call u_bat_test			;funkcja sprawdzajace stan akumulatora
	btfss acu_test_reg, 1	
	goto acu4_end
	bsf I4_ON_A		;LADOWANIE 125mA OFF
	bsf I4_ON_B		;LADOWANIE 250mA OFF
	movlw h'40'
	movwf c_bat4			
	call disp_bat4_ch
	bsf acu4_stat, 4		;ukonczono proces adowania
	movlw #line4_lcd
	movwf i2cdata
	call lcd	
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	movlw #shift_cursorr
	movwf i2cdata
	call lcd	
	movlw #'1'
	movwf i2cdata
	call write_lcd
	movlw #'0'
	movwf i2cdata
	call write_lcd	
	movlw #'0'
	movwf i2cdata
	call write_lcd
	goto acu4_end			;funkcja ladowania
acu4_end
	return
;********************************************************
;wyswietlenie pojemnosci ACU AA
display_caa
	movlw #shift_cursorr	;
	movwf i2cdata
	call LCD	
	movlw #shift_cursorr	;
	movwf i2cdata
	call LCD	
	incf hx1, 1
	decf hx1, 1
	btfss status, z
	goto display_caa1
	movlw #' ' ;
	movwf i2cdata
	call WRITE_LCD	
;
	incf mx10, 1
	decf mx10, 1
	btfss status, z
	goto display_caa1a
	movlw #' ' ;
	movwf i2cdata
	call WRITE_LCD	
;
	incf mx1, 1
	decf mx1, 1
	btfss status, z
	goto display_caa1b
	movlw #' ' ;
	movwf i2cdata
	call WRITE_LCD	
	goto display_caa1c
display_caa1
	movf hx1, 0	;wpisz hx1 do W	1000x mAh
	iorlw h'30'
	movwf i2cdata
	call write_lcd
;
display_caa1a
	movf mx10, 0	;wpisz hx1 do W	100x mAh
	iorlw h'30'
	movwf i2cdata
	call write_lcd
;
display_caa1b
	movf mx1, 0	;wpisz hx1 do W	10x mAh
	iorlw h'30'
	movwf i2cdata
	call write_lcd
display_caa1c
	movf sx10, 0	;wpisz hx1 do W	1x mAh
	iorlw h'30'
	movwf i2cdata
	call write_lcd
	return
;
;wyswietlenie pojemnosci ACU AAA
display_caaa
	movlw #shift_cursorr	;
	movwf i2cdata
	call LCD	
	movlw #shift_cursorr	;
	movwf i2cdata
	call LCD	
	incf mAhx1000, 1
	decf mAhx1000, 1
	btfss status, z
	goto display_caaa1
	movlw #' ' ;
	movwf i2cdata
	call WRITE_LCD	
;
	incf mAhx100, 1
	decf mAhx100, 1
	btfss status, z
	goto display_caaa1a
	movlw #' ' ;
	movwf i2cdata
	call WRITE_LCD	
;
	incf mAhx10, 1
	decf mAhx10, 1
	btfss status, z
	goto display_caaa1b
	movlw #' ' ;
	movwf i2cdata
	call WRITE_LCD	
	goto display_caaa1c
display_caaa1
	movf mAhx1000, 0	;wpisz hx1 do W	1000x mAh
	iorlw h'30'
	movwf i2cdata
	call write_lcd
;
display_caaa1a
	movf mAhx100, 0	;wpisz hx1 do W	100x mAh
	iorlw h'30'
	movwf i2cdata
	call write_lcd
;
display_caaa1b
	movf mAhx10, 0	;wpisz hx1 do W	10x mAh
	iorlw h'30'
	movwf i2cdata
	call write_lcd
display_caaa1c
	movf mAhx1, 0	;wpisz hx1 do W	1x mAh
	iorlw h'30'
	movwf i2cdata
	call write_lcd
;
	return
;*************************************************************************
;funkcja wyswietlania ladowania baterii nr 1
disp_bat1_ch
	call acu1_pom		;pomiar napiecia
	movf adresh, 0		; wynik ADC do W
	movwf i2cdata		;zapis ADC do rej. pom.
	call delay10
	call acu1_pom
	movf adresh, 0		; wynik ADC do W
	subwf i2cdata, 0
	btfss status, z	
	goto disp_bat1_ch         
	movlw #line1_lcd
	movwf i2cdata
	call lcd
;
	call disp_pom		;wyswietlenie % naladowania
;
	movf c_bat1, 0
	movwf licznik
	call disp_bat_ch
	movf licznik, 0
	movwf c_bat1
	return
;sprawdzanie ile procent naladowania
disp_pom
	movlw h'FC'
	movwf licznik
disp_pom0
	movlw #shift_cursorr
	movwf i2cdata
	call lcd
	incf licznik, 1
	btfsc licznik, 7
	goto disp_pom0
	movlw #' '			;0% ladowania
	movwf i2cdata
	movlw h'79'			;'68'			;wartosc 10%
	subwf adresh, 0
	btfss status, c	
	goto disp_pom1
	movlw #'1'			;10% ladowania
	movwf i2cdata
	movlw h'7b'			;'6A'			;wartosc 20%
	subwf adresh, 0
	btfss status, c	
	goto disp_pom1
	movlw #'2'			;20% ladowania
	movwf i2cdata
	movlw h'7c'			;'6C'			;wartosc 30%
	subwf adresh, 0
	btfss status, c	
	goto disp_pom1
	movlw #'3'			;30% ladowania
	movwf i2cdata
	movlw h'7e'			;'6D'			;wartosc 40%
	subwf adresh, 0
	btfss status, c	
	goto disp_pom1
	movlw #'4'			;40% ladowania
	movwf i2cdata
	movlw h'80'			;'6F'			;wartosc 50%
	subwf adresh, 0
	btfss status, c	
	goto disp_pom1
	movlw #'5'			;50% ladowania
	movwf i2cdata
	movlw h'82'			;'70'			;wartosc 60%
	subwf adresh, 0
	btfss status, c	
	goto disp_pom1
	movlw #'6'			;60% ladowania
	movwf i2cdata
	movlw h'84'			;'76'			;wartosc 70%
	subwf adresh, 0
	btfss status, c	
	goto disp_pom1
	movlw #'7'			;70% ladowania
	movwf i2cdata
	movlw h'85'			;'7C'			;wartosc 80%
	subwf adresh, 0
	btfss status, c	
	goto disp_pom1
	movlw #'8'			;80% ladowania
	movwf i2cdata
	movlw h'90'			;'85'			;wartosc 90%
	subwf adresh, 0
	btfss status, c	
	goto disp_pom1
	movlw #'9'			;80% ladowania
	movwf i2cdata
disp_pom1
	call write_lcd
;
	movlw h'FD'			;bylo FC !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	movwf licznik
disp_pom2
	movlw #shift_cursorr
	movwf i2cdata
	call lcd
	incf licznik, 1
	btfsc licznik, 7
	goto disp_pom2
	movlw #' '			;80% ladowania
	movwf i2cdata
	call write_lcd
	return
;
;funkcja wyswietlania ladowania baterii nr 2
disp_bat2_ch
	call acu2_pom		;pomiar napiecia
	movf adresh, 0		; wynik ADC do W
	movwf i2cdata		;zapis ADC do rej. pom.
	call delay10
	call acu2_pom
	movf adresh, 0		; wynik ADC do W
	subwf i2cdata, 0
	btfss status, z	
	goto disp_bat2_ch         
	movlw #line2_lcd
	movwf i2cdata
	call lcd
	call disp_pom		;wyswietlenie % naladowania
	movf c_bat2, 0
	movwf licznik
	call disp_bat_ch
	movf licznik, 0
	movwf c_bat2
	return
;
;funkcja wyswietlania ladowania baterii nr 3
disp_bat3_ch
	call acu3_pom		;pomiar napiecia
	movf adresh, 0		; wynik ADC do W
	movwf i2cdata		;zapis ADC do rej. pom.
	call delay10
	call acu3_pom
	movf adresh, 0		; wynik ADC do W
	subwf i2cdata, 0
	btfss status, z	
	goto disp_bat3_ch         
	movlw #line3_lcd
	movwf i2cdata
	call lcd
	call disp_pom		;wyswietlenie % naladowania
	movf c_bat3, 0
	movwf licznik
	call disp_bat_ch
	movf licznik, 0
	movwf c_bat3
	return
;funkcja wyswietlania ladowania baterii nr 4
disp_bat4_ch
	call acu4_pom		;pomiar napiecia
	movf adresh, 0		; wynik ADC do W
	movwf i2cdata		;zapis ADC do rej. pom.
	call delay10
	call acu4_pom
	movf adresh, 0		; wynik ADC do W
	subwf i2cdata, 0
	btfss status, z	
	goto disp_bat4_ch         
	movlw #line4_lcd
	movwf i2cdata
	call lcd
	call disp_pom		;wyswietlenie % naladowania
	movf c_bat4, 0
	movwf licznik
	call disp_bat_ch
	movf licznik, 0
	movwf c_bat4
	bcf status, rp0		;bank0
	return
;
;ogolna funkcja rysowania ladowania bat.
disp_bat_ch
	btfss licznik, 0
	goto disp_bat1
	movlw h'00'
	movwf i2cdata
	call write_lcd
	movlw b'00000010'
	goto disp_bat_end
disp_bat1
	btfss licznik, 1
	goto disp_bat2
	movlw h'01'
	movwf i2cdata
	call write_lcd
	movlw b'00000100'
	goto disp_bat_end
disp_bat2
	btfss licznik, 2
	goto disp_bat3
	movlw h'02'
	movwf i2cdata
	call write_lcd
	movlw b'00001000'
	goto disp_bat_end
disp_bat3
	btfss licznik, 3
	goto disp_bat4
	movlw h'03'
	movwf i2cdata
	call write_lcd
	movlw b'00010000'
	goto disp_bat_end
disp_bat4
	btfss licznik, 4
	goto disp_bat5
	movlw h'04'
	movwf i2cdata
	call write_lcd
	movlw b'00100000'
	goto disp_bat_end
disp_bat5
	movlw h'05'
	movwf i2cdata
	call write_lcd
	movlw b'00000001'
disp_bat_end
	movwf licznik
	return
;
;funkcja wyswietlania rozladowania baterii nr 1
disp_bat1_dch
	movlw #line1_lcd
	movwf i2cdata
	call lcd
	movlw h'F8'					;BYLO F7 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	movwf licznik
disp_bat1_dch1
	movlw #shift_cursorr
	movwf i2cdata
	call lcd
	incf licznik, 1
	btfsc licznik, 7
	goto disp_bat1_dch1
	movf c_bat1, 0
	movwf licznik
;
	movlw 'h'
	movwf i2cdata
	movlw ' '
	btfsc acu1_stat, 0
	movwf i2cdata
	btfsc acu1_stat, 1
	movwf i2cdata
;	
	call disp_bat_dch
	movf licznik, 0
	movwf c_bat1
	return
;funkcja wyswietlania rozladowania baterii nr 2
disp_bat2_dch
	movlw #line2_lcd
	movwf i2cdata
	call lcd
	movlw h'F8'
	movwf licznik
disp_bat2_dch1
	movlw #shift_cursorr
	movwf i2cdata
	call lcd
	incf licznik, 1
	btfsc licznik, 7
	goto disp_bat2_dch1
	movf c_bat2, 0
	movwf licznik
	movlw 'h'
	movwf i2cdata
	movlw ' '
	btfsc acu2_stat, 0
	movwf i2cdata
	btfsc acu2_stat, 1
	movwf i2cdata
	call disp_bat_dch
	movf licznik, 0
	movwf c_bat2
	return
;funkcja wyswietlania rozladowania baterii nr 3
disp_bat3_dch
	movlw #line3_lcd
	movwf i2cdata
	call lcd
	movlw h'F8'
	movwf licznik
disp_bat3_dch1
	movlw #shift_cursorr
	movwf i2cdata
	call lcd
	incf licznik, 1
	btfsc licznik, 7
	goto disp_bat3_dch1
	movf c_bat3, 0
	movwf licznik
	movlw 'h'
	movwf i2cdata
	movlw ' '
	btfsc acu3_stat, 0
	movwf i2cdata
	btfsc acu3_stat, 1
	movwf i2cdata
	call disp_bat_dch
	movf licznik, 0
	movwf c_bat3
	return
;funkcja wyswietlania rozladowania baterii nr 4
disp_bat4_dch
	movlw #line4_lcd
	movwf i2cdata
	call lcd
	movlw h'F8'				; F7
	movwf licznik
disp_bat4_dch1
	movlw #shift_cursorr
	movwf i2cdata
	call lcd
	incf licznik, 1
	btfsc licznik, 7
	goto disp_bat4_dch1
	movf c_bat4, 0
	movwf licznik
	movlw 'h'
	movwf i2cdata
	movlw ' '
	btfsc acu4_stat, 0
	movwf i2cdata
	btfsc acu4_stat, 1
	movwf i2cdata
	call disp_bat_dch
	movf licznik, 0
	movwf c_bat4
	return
;ogolna funkcja wizualizacji rozladowania bat
disp_bat_dch
	call write_lcd
	btfss licznik, 0
	goto disp_batd1
	movlw h'05'
	movwf i2cdata
	call write_lcd
	movlw b'00000010'
	goto disp_batd_end
disp_batd1
	btfss licznik, 1
	goto disp_batd2
	movlw h'04'
	movwf i2cdata
	call write_lcd
	movlw b'00000100'
	goto disp_batd_end
disp_batd2
	btfss licznik, 2
	goto disp_batd3
	movlw h'03'
	movwf i2cdata
	call write_lcd
	movlw b'00001000'
	goto disp_batd_end
disp_batd3
	btfss licznik, 3
	goto disp_batd4
	movlw h'02'
	movwf i2cdata
	call write_lcd
	movlw b'00010000'
	goto disp_batd_end
disp_batd4
	btfss licznik, 4
	goto disp_batd5
	movlw h'01'
	movwf i2cdata
	call write_lcd
	movlw b'00100000'
	goto disp_batd_end
disp_batd5
	movlw h'00'
	movwf i2cdata
	call write_lcd
	movlw b'00000001'
disp_batd_end
	movwf licznik
	return
;********************************************************
;pomiar napiecia acu1
acu1_pom
	bcf status, rp0		;bank0
	bcf status, rp1		;bank0
	movlw h'A1'			; 
	movwf adcon0 		;ADC on AN4 (RA5)
	call delay0255		;ustabilizowanie kluczy
	bsf adcon0, 2		;start pomiaru
	call delay0255
	btfsc adcon0, 2
	goto $-1
	return
;
;pomiar napiecia acu2
acu2_pom
	bcf status, rp0		;bank0
	bcf status, rp1		;bank0
	movlw h'89'			; 
	movwf adcon0 		;ADC on AN1 (RA1)
	call delay0255		;ustabilizowanie kluczy
	bsf adcon0, 2		;start pomiaru
	call delay0255
	btfsc adcon0, 2
	goto $-1
	return
;pomiar napiecia acu3
acu3_pom
	bcf status, rp0		;bank0
	bcf status, rp1		;bank0
	movlw h'91'			; 
	movwf adcon0 		;ADC on AN2 (RA2)
	call delay0255		;ustabilizowanie kluczy
	bsf adcon0, 2		;start pomiaru
	call delay0255
	btfsc adcon0, 2
	goto $-1
	return
;pomiar napiecia acu4
acu4_pom
	bcf status, rp0		;bank0
	bcf status, rp1		;bank0
	movlw h'81'			; 
	movwf adcon0 		;ADC on AN0 (RA0)
	call delay0255		;ustabilizowanie kluczy
	bsf adcon0, 2		;start pomiaru
	call delay0255
	btfsc adcon0, 2
	goto $-1
	return
;sprawdza napiecie baterii na podstawie danych adresh
; wynik w acu_test_reg 	;01h - Uacu<1,05V
						;02h - Uacu>1,43V
u_bat_test
	bcf status, rp0		;bank0
	bcf status, rp1		;bank0
	clrf acu_test_reg
	movf adresh, 0		;przeslij adresh do W
	sublw h'6B'			;W=6Bh - W ; 6Bh - 1,05V
	btfsc status, c
	goto u_bat_test_end1	;Uacu<1,05V
	movf adresh, 0		;przeslij adresh do W
	sublw h'90'			;W=92h - W ; 92h - 1,43V		;BYLO 92 !!!!!!!!!!!!!!!!!!!!!!!!!!
	btfsc status, c
	goto u_bat_test_end		;1,05v<Uacu<1,43V 
	movlw h'02'
	movwf acu_test_reg		;Uacu>1,43V
	goto u_bat_test_end
u_bat_test_end1
	movlw h'01'
	movwf acu_test_reg ;Uacu<1,05V
u_bat_test_end
	return
;********************************************************************************
;przeskok do PC>2kB
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	org h'800'
;********************************************************************************
;opoznienie o 255us
delay255
	movlw h'46'	; 
	movwf dpl
delay255_0				; funkcja opoxnienia 0 255us
	decfsz dpl, 0		;
	goto delay255_1
	goto delay255_end
delay255_1
	movwf dpl
	goto delay255_0
delay255_end
	return
;****************************************************************************************************************
;obsluga timera
timer0_int
	movwf stos
	swapf status,w
	movwf stos1
	bcf status, rp0		;bank0
	bcf status, rp1		;bank0
	movf tmr0, 0
	addlw h'3D'
	movwf tmr0
	incf pom, 1			;wskaznik  
	btfsc pom, 7
	goto timer0_int1
	movlw h'EC'			; 
	movwf pom 		;
	call inc_time		;inkrementacja czasu
	bsf bit_reg, 0		;znacznik uplywy czasu
timer0_int1
	swapf stos1,w
	movwf status
	swapf stos,1
	swapf stos,w
	bcf status, rp0		;bank0
	bcf intcon, tmr0if	;	zerowanie wskaxnika od przerwania	
;
	clrf pclath
;
	return
;****************************************************************
;inkrementacja czasu
;inkrementacja mAh
inc_time
	incf hx10, 1
	incf sx1, 1
	btfss sx1, 3
	goto inc_time_end
	btfss sx1, 1
	goto inc_time_end
;
	clrf sx1
	incf sx10, 1		;1x mAh
	btfss sx10, 3
	goto inc_time_end
	btfss sx10, 1
	goto inc_time_end
;
	clrf sx10
	incf mx1, 1		;10x mAh
	btfss mx1, 3
	goto inc_time_end
	btfss mx1, 1
	goto inc_time_end
;
	clrf mx1
	incf mx10, 1		;100x mAh
	btfss mx10, 3
	goto inc_time_end
	btfss mx10, 1
	goto inc_time_end
;
	clrf mx10
	incf hx1, 1		;1000x mAh
inc_time_end
	btfsc hx10, 7	;czy minelo 20s
	goto inc_time_end1
	movlw h'EC'			; 
	movwf hx10 		;	
	incf mAhx1, 1		;1x mAh AAA
	btfss mAhx1, 3
	goto inc_time_end1
	btfss mAhx1, 1
	goto inc_time_end1
;
	clrf mAhx1
	incf mAhx10, 1		;10x mAh
	btfss mAhx10, 3
	goto inc_time_end1
	btfss mAhx10, 1
	goto inc_time_end1
;
	clrf mAhx10
	incf mAhx100, 1		;100x mAh
	btfss mAhx100, 3
	goto inc_time_end1
	btfss mAhx100, 1
	goto inc_time_end1
	clrf mAhx100
	incf mAhx1000, 1		;1000x mAh
inc_time_end1
	return
;*****************************************************
;poczatkowe ustawienie portw
;zaden akumulator nir jest ladowany ani rozladowywany
reset_port
	bsf AAA1 		;AKU1, rozladowanie aku AA
	bsf AAA2 		;AKU2, rozladowanie aku AA
	bsf AAA3 		;AKU3, rozladowanie aku AA
	bsf AAA4		;AKU4, rozladowanie aku AA
;
	bsf ID1_ON 		;AKU1 rozladowanie aku1 OFF
	bsf ID2_ON 		;AKU2 rozladowanie aku2 OFF
	bsf ID3_ON 		;AKU3 rozladowanie aku3 OFF
	bsf ID4_ON 		;AKU4 rozladowanie aku4 OFF
;
	bsf I1_ON_A 	;AKU1 ladowanie AKU1 - 1/2 pradu OFF
	bsf I1_ON_B 	;AKU1 ladowanie AKU1 - 2/2 pradu OFF
	bsf I2_ON_A 	;AKU2 ladowanie AKU2 - 1/2 pradu OFF
	bsf I2_ON_B 	;AKU2 ladowanie AKU2 - 2/2 pradu OFF
	bsf I3_ON_A 	;AKU3 ladowanie AKU3 - 1/2 pradu OFF
	bsf I3_ON_B 	;AKU3 ladowanie AKU3 - 2/2 pradu OFF
	bsf I4_ON_A 	;AKU4 ladowanie AKU4 - 1/2 pradu OFF
	bsf I4_ON_B 	;AKU4 ladowanie AKU4 - 2/2 pradu OFF
;
	movlw h'01' 			;zwrucenie adresu do licznika PC - PCLATCH
	movwf pclath
;
	return
; zerowanie czasu
time_reset
	movlw h'EC'
	movwf hx10			;zerowanie wskazan zegara
	clrf hx1
	clrf mx10
	clrf mx1
	clrf sx10
	clrf sx1
;
	clrf mAhx1000
	clrf mAhx100
	clrf mAhx10
	clrf mAhx1
;
	movlw h'01' 			;zwrucenie adresu do licznika PC - PCLATCH
	movwf pclath
;
	return
;*************************************************************************
BIG
	banksel trisc	
	movlw b'00011000'			; 
	movwf trisc			;wyjscia
	banksel sspcon
	movlw b'00101000'			; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	movwf sspcon			;
	banksel sspstat
	movlw b'10000000'			; 
	movwf sspstat
	banksel sspadd			;
	movlw h'7C'			; 
	movwf sspadd
	bcf intcon, gie
	banksel sspcon2
	bsf sspcon2, sen	;start
	call i2c_wait1
	movlw h'78'			
	movwf sspbuf		;adres dogs104b 078h (zapis)
	call i2c_wait1
	movlw h'80'			
	movwf sspbuf		;control byte - RAM
	call i2c_wait1
	movlw h'3A'			;bylo 3A			
	movwf sspbuf		;zapisz A
	call i2c_wait1
	call delay255	
	movlw h'17'			
	movwf sspbuf		;zapisz A
	call i2c_wait1
	call delay255	
	movlw h'3C'					;3c
	movwf sspbuf		;zapisz A
	call i2c_wait1
	call delay255	
	banksel sspcon2
	bsf sspcon2, pen	;bit stop
	bcf status, rp0		;bank 0
	call i2c_wait1
	bsf intcon, gie
;
	movlw h'01' 			;zwrucenie adresu do licznika PC - PCLATCH
	movwf pclath
;
	return
;*********************************************************************
;funkcja sprawdzania zajetosci i2c
i2c_wait1
	banksel sspstat
	btfsc sspstat, R_W
	goto $-1
	banksel sspcon2
	movf sspcon2, w		;wylacz dla proby
	andlw h'1f'
	btfss status, z
	goto $-3
	bcf status, rp0		;bank 0
	return
;
;
	end